]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - etc/rc.subr
This commit was generated by cvs2svn to compensate for changes in r159285,
[FreeBSD/FreeBSD.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.66 2006/04/01 10:05:50 he Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 # 3. All advertising materials mentioning features or use of this software
19 #    must display the following acknowledgement:
20 #        This product includes software developed by the NetBSD
21 #        Foundation, Inc. and its contributors.
22 # 4. Neither the name of The NetBSD Foundation nor the names of its
23 #    contributors may be used to endorse or promote products derived
24 #    from this software without specific prior written permission.
25 #
26 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36 # POSSIBILITY OF SUCH DAMAGE.
37 #
38 # rc.subr
39 #       functions used by various rc scripts
40 #
41
42 : ${rcvar_manpage:='rc.conf(5)'}
43
44 #
45 #       Operating System dependent/independent variables
46 #
47
48 if [ -z "${_rc_subr_loaded}" ]; then
49
50 _rc_subr_loaded="YES"
51
52 SYSCTL="/sbin/sysctl"
53 SYSCTL_N="${SYSCTL} -n"
54 CMD_OSTYPE="${SYSCTL_N} kern.ostype"
55 OSTYPE=`${CMD_OSTYPE}`
56 ID="/usr/bin/id"
57 JID=`ps -p $$ -o jid=`
58 IDCMD="if [ -x $ID ]; then $ID -un; fi"
59
60 case ${OSTYPE} in
61 FreeBSD)
62         SYSCTL_W="${SYSCTL}"
63         ;;
64 NetBSD)
65         SYSCTL_W="${SYSCTL} -w"
66         ;;
67 esac
68
69 #
70 #       functions
71 #       ---------
72
73 #
74 # set_rcvar base_var
75 #       Set the variable name enabling a specific service.
76 #       FreeBSD uses ${service}_enable, while NetBSD uses
77 #       just the name of the service. For example:
78 #       FreeBSD: sendmail_enable="YES"
79 #       NetBSD : sendmail="YES"
80 #       $1 - if $name is not the base to work of off, specify
81 #            a different one
82 #
83 set_rcvar()
84 {
85         if [ -z "$1" ]; then
86                 base_var=${name}
87         else
88                 base_var="$1"
89         fi
90
91         case ${OSTYPE} in
92         FreeBSD)
93                 echo ${base_var}_enable
94                 ;;
95         NetBSD)
96                 echo ${base_var}
97                 ;;
98         *)
99                 echo 'XXX'
100                 ;;
101         esac
102 }
103
104 #
105 # force_depend script
106 #       Force a service to start. Intended for use by services
107 #       to resolve dependency issues. It is assumed the caller
108 #       has check to make sure this call is necessary
109 #       $1 - filename of script, in /etc/rc.d, to run
110 #
111 force_depend()
112 {
113         _depend="$1"
114
115         info "${name} depends on ${_depend}, which will be forced to start."
116         if ! /etc/rc.d/${_depend} forcestart; then
117                 warn "Unable to force ${_depend}. It may already be running."
118                 return 1
119         fi
120         return 0
121 }
122
123 #
124 # checkyesno var
125 #       Test $1 variable, and warn if not set to YES or NO.
126 #       Return 0 if it's "yes" (et al), nonzero otherwise.
127 #
128 checkyesno()
129 {
130         eval _value=\$${1}
131         debug "checkyesno: $1 is set to $_value."
132         case $_value in
133
134                 #       "yes", "true", "on", or "1"
135         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
136                 return 0
137                 ;;
138
139                 #       "no", "false", "off", or "0"
140         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
141                 return 1
142                 ;;
143         *)
144                 warn "\$${1} is not set properly - see ${rcvar_manpage}."
145                 return 1
146                 ;;
147         esac
148 }
149
150 #
151 # reverse_list list
152 #       print the list in reverse order
153 #
154 reverse_list()
155 {
156         _revlist=
157         for _revfile; do
158                 _revlist="$_revfile $_revlist"
159         done
160         echo $_revlist
161 }
162
163 #
164 # mount_critical_filesystems type
165 #       Go through the list of critical filesystems as provided in
166 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
167 #       each one to see if it is mounted, and if it is not, mounting it.
168 #
169 mount_critical_filesystems()
170 {
171         eval _fslist=\$critical_filesystems_${1}
172         for _fs in $_fslist; do
173                 mount | (
174                         _ismounted=false
175                         while read what _on on _type type; do
176                                 if [ $on = $_fs ]; then
177                                         _ismounted=true
178                                 fi
179                         done
180                         if $_ismounted; then
181                                 :
182                         else
183                                 mount $_fs >/dev/null 2>&1
184                         fi
185                 )
186         done
187 }
188
189 #
190 # check_pidfile pidfile procname [interpreter]
191 #       Parses the first line of pidfile for a PID, and ensures
192 #       that the process is running and matches procname.
193 #       Prints the matching PID upon success, nothing otherwise.
194 #       interpreter is optional; see _find_processes() for details.
195 #
196 check_pidfile()
197 {
198         _pidfile=$1
199         _procname=$2
200         _interpreter=$3
201         if [ -z "$_pidfile" -o -z "$_procname" ]; then
202                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
203         fi
204         if [ ! -f $_pidfile ]; then
205                 debug "pid file ($_pidfile): not readable."
206                 return
207         fi
208         read _pid _junk < $_pidfile
209         if [ -z "$_pid" ]; then
210                 debug "pid file ($_pidfile): no pid in file."
211                 return
212         fi
213         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
214 }
215
216 #
217 # check_process procname [interpreter]
218 #       Ensures that a process (or processes) named procname is running.
219 #       Prints a list of matching PIDs.
220 #       interpreter is optional; see _find_processes() for details.
221 #
222 check_process()
223 {
224         _procname=$1
225         _interpreter=$2
226         if [ -z "$_procname" ]; then
227                 err 3 'USAGE: check_process procname [interpreter]'
228         fi
229         _find_processes $_procname ${_interpreter:-.} '-ax'
230 }
231
232 #
233 # _find_processes procname interpreter psargs
234 #       Search for procname in the output of ps generated by psargs.
235 #       Prints the PIDs of any matching processes, space separated.
236 #
237 #       If interpreter == ".", check the following variations of procname
238 #       against the first word of each command:
239 #               procname
240 #               `basename procname`
241 #               `basename procname` + ":"
242 #               "(" + `basename procname` + ")"
243 #               "[" + `basename procname` + "]"
244 #
245 #       If interpreter != ".", read the first line of procname, remove the
246 #       leading #!, normalise whitespace, append procname, and attempt to
247 #       match that against each command, either as is, or with extra words
248 #       at the end.  As an alternative, to deal with interpreted daemons
249 #       using perl, the basename of the interpreter plus a colon is also
250 #       tried as the prefix to procname.
251 #
252 _find_processes()
253 {
254         if [ $# -ne 3 ]; then
255                 err 3 'USAGE: _find_processes procname interpreter psargs'
256         fi
257         _procname=$1
258         _interpreter=$2
259         _psargs=$3
260
261         _pref=
262         if [ $_interpreter != "." ]; then       # an interpreted script
263                 read _interp < $_procname       # read interpreter name
264                 _interp=${_interp#\#!}          # strip #!
265                 set -- $_interp
266                 if [ $_interpreter != $1 ]; then
267                         warn "\$command_interpreter $_interpreter != $1"
268                 fi
269                 _interp="$* $_procname"         # cleanup spaces, add _procname
270                 _interpbn=${1##*/}
271                 _fp_args='_argv'
272                 _fp_match='case "$_argv" in
273                     ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
274         else                                    # a normal daemon
275                 _procnamebn=${_procname##*/}
276                 _fp_args='_arg0 _argv'
277                 _fp_match='case "$_arg0" in
278                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
279         fi
280
281         _proccheck='
282                 ps 2>/dev/null -o "pid,jid,command" '"$_psargs"' |
283                 while read _npid _jid '"$_fp_args"'; do
284                         case "$_npid" in
285                         PID)
286                                 continue;;
287                         esac; '"$_fp_match"'
288                                 if [ "$JID" -eq "$_jid" ];
289                                 then echo -n "$_pref$_npid";
290                                 _pref=" ";
291                                 fi
292                                 ;;
293                         esac
294                 done'
295
296 #       debug "in _find_processes: proccheck is ($_proccheck)."
297         eval $_proccheck
298 }
299
300 #
301 # wait_for_pids pid [pid ...]
302 #       spins until none of the pids exist
303 #
304 wait_for_pids()
305 {
306         _list="$@"
307         if [ -z "$_list" ]; then
308                 return
309         fi
310         _prefix=
311         while true; do
312                 _nlist="";
313                 for _j in $_list; do
314                         if kill -0 $_j 2>/dev/null; then
315                                 _nlist="${_nlist}${_nlist:+ }$_j"
316                         fi
317                 done
318                 if [ -z "$_nlist" ]; then
319                         break
320                 fi
321                 _list=$_nlist
322                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
323                 _prefix=", "
324                 sleep 2
325         done
326         if [ -n "$_prefix" ]; then
327                 echo "."
328         fi
329 }
330
331 #
332 # run_rc_command argument
333 #       Search for argument in the list of supported commands, which is:
334 #               "start stop restart rcvar status poll ${extra_commands}"
335 #       If there's a match, run ${argument}_cmd or the default method
336 #       (see below).
337 #
338 #       If argument has a given prefix, then change the operation as follows:
339 #               Prefix  Operation
340 #               ------  ---------
341 #               fast    Skip the pid check, and set rc_fast=yes
342 #               force   Set ${rcvar} to YES, and set rc_force=yes
343 #               one     Set ${rcvar} to YES
344 #
345 #       The following globals are used:
346 #
347 #       Name            Needed  Purpose
348 #       ----            ------  -------
349 #       name            y       Name of script.
350 #
351 #       command         n       Full path to command.
352 #                               Not needed if ${rc_arg}_cmd is set for
353 #                               each keyword.
354 #
355 #       command_args    n       Optional args/shell directives for command.
356 #
357 #       command_interpreter n   If not empty, command is interpreted, so
358 #                               call check_{pidfile,process}() appropriately.
359 #
360 #       extra_commands  n       List of extra commands supported.
361 #
362 #       pidfile         n       If set, use check_pidfile $pidfile $command,
363 #                               otherwise use check_process $command.
364 #                               In either case, only check if $command is set.
365 #
366 #       procname        n       Process name to check for instead of $command.
367 #
368 #       rcvar           n       This is checked with checkyesno to determine
369 #                               if the action should be run.
370 #
371 #       ${name}_program n       Full path to command.
372 #                               Meant to be used in /etc/rc.conf to override
373 #                               ${command}.
374 #
375 #       ${name}_chroot  n       Directory to chroot to before running ${command}
376 #                               Requires /usr to be mounted.
377 #
378 #       ${name}_chdir   n       Directory to cd to before running ${command}
379 #                               (if not using ${name}_chroot).
380 #
381 #       ${name}_flags   n       Arguments to call ${command} with.
382 #                               NOTE:   $flags from the parent environment
383 #                                       can be used to override this.
384 #
385 #       ${name}_nice    n       Nice level to run ${command} at.
386 #
387 #       ${name}_user    n       User to run ${command} as, using su(1) if not
388 #                               using ${name}_chroot.
389 #                               Requires /usr to be mounted.
390 #
391 #       ${name}_group   n       Group to run chrooted ${command} as.
392 #                               Requires /usr to be mounted.
393 #
394 #       ${name}_groups  n       Comma separated list of supplementary groups
395 #                               to run the chrooted ${command} with.
396 #                               Requires /usr to be mounted.
397 #
398 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
399 #                               Otherwise, use default command (see below)
400 #
401 #       ${rc_arg}_precmd n      If set, run just before performing the
402 #                               ${rc_arg}_cmd method in the default
403 #                               operation (i.e, after checking for required
404 #                               bits and process (non)existence).
405 #                               If this completes with a non-zero exit code,
406 #                               don't run ${rc_arg}_cmd.
407 #
408 #       ${rc_arg}_postcmd n     If set, run just after performing the
409 #                               ${rc_arg}_cmd method, if that method
410 #                               returned a zero exit code.
411 #
412 #       required_dirs   n       If set, check for the existence of the given
413 #                               directories before running the default
414 #                               (re)start command.
415 #
416 #       required_files  n       If set, check for the readability of the given
417 #                               files before running the default (re)start
418 #                               command.
419 #
420 #       required_vars   n       If set, perform checkyesno on each of the
421 #                               listed variables before running the default
422 #                               (re)start command.
423 #
424 #       Default behaviour for a given argument, if no override method is
425 #       provided:
426 #
427 #       Argument        Default behaviour
428 #       --------        -----------------
429 #       start           if !running && checkyesno ${rcvar}
430 #                               ${command}
431 #
432 #       stop            if ${pidfile}
433 #                               rc_pid=$(check_pidfile $pidfile $command)
434 #                       else
435 #                               rc_pid=$(check_process $command)
436 #                       kill $sig_stop $rc_pid
437 #                       wait_for_pids $rc_pid
438 #                       ($sig_stop defaults to TERM.)
439 #
440 #       reload          Similar to stop, except use $sig_reload instead,
441 #                       and doesn't wait_for_pids.
442 #                       $sig_reload defaults to HUP.
443 #                       Note that `reload' isn't provided by default,
444 #                       it should be enabled via $extra_commands.
445 #
446 #       restart         Run `stop' then `start'.
447 #
448 #       status          Show if ${command} is running, etc.
449 #
450 #       poll            Wait for ${command} to exit.
451 #
452 #       rcvar           Display what rc.conf variable is used (if any).
453 #
454 #       Variables available to methods, and after run_rc_command() has
455 #       completed:
456 #
457 #       Variable        Purpose
458 #       --------        -------
459 #       rc_arg          Argument to command, after fast/force/one processing
460 #                       performed
461 #
462 #       rc_flags        Flags to start the default command with.
463 #                       Defaults to ${name}_flags, unless overridden
464 #                       by $flags from the environment.
465 #                       This variable may be changed by the precmd method.
466 #
467 #       rc_pid          PID of command (if appropriate)
468 #
469 #       rc_fast         Not empty if "fast" was provided (q.v.)
470 #
471 #       rc_force        Not empty if "force" was provided (q.v.)
472 #
473 #
474 run_rc_command()
475 {
476         _return=0
477         rc_arg=$1
478         if [ -z "$name" ]; then
479                 err 3 'run_rc_command: $name is not set.'
480         fi
481
482         # Don't repeat the first argument when passing additional command-
483         # line arguments to the command subroutines.
484         #
485         shift 1
486         rc_extra_args="$*"
487
488         _rc_prefix=
489         case "$rc_arg" in
490         fast*)                          # "fast" prefix; don't check pid
491                 rc_arg=${rc_arg#fast}
492                 rc_fast=yes
493                 ;;
494         force*)                         # "force prefix; always run
495                 rc_force=yes
496                 _rc_prefix=force
497                 rc_arg=${rc_arg#${_rc_prefix}}
498                 if [ -n "${rcvar}" ]; then
499                         eval ${rcvar}=YES
500                 fi
501                 ;;
502         one*)                           # "one" prefix; set ${rcvar}=yes
503                 _rc_prefix=one
504                 rc_arg=${rc_arg#${_rc_prefix}}
505                 if [ -n "${rcvar}" ]; then
506                         eval ${rcvar}=YES
507                 fi
508                 ;;
509         esac
510
511         _keywords="start stop restart rcvar $extra_commands"
512         rc_pid=
513         _pidcmd=
514         _procname=${procname:-${command}}
515
516                                         # setup pid check command
517         if [ -n "$_procname" ]; then
518                 if [ -n "$pidfile" ]; then
519                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
520                 else
521                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
522                 fi
523                 if [ -n "$_pidcmd" ]; then
524                         _keywords="${_keywords} status poll"
525                 fi
526         fi
527
528         if [ -z "$rc_arg" ]; then
529                 rc_usage $_keywords
530         fi
531
532         if [ -n "$flags" ]; then        # allow override from environment
533                 rc_flags=$flags
534         else
535                 eval rc_flags=\$${name}_flags
536         fi
537         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
538             _nice=\$${name}_nice        _user=\$${name}_user \
539             _group=\$${name}_group      _groups=\$${name}_groups
540
541         if [ -n "$_user" ]; then        # unset $_user if running as that user
542                 if [ "$_user" = "$(eval $IDCMD)" ]; then
543                         unset _user
544                 fi
545         fi
546
547                                         # if ${rcvar} is set, and $1 is not
548                                         # "rcvar", then run
549                                         #       checkyesno ${rcvar}
550                                         # and return if that failed
551                                         #
552         if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
553                 if ! checkyesno ${rcvar}; then
554                         return 0
555                 fi
556         fi
557
558         eval $_pidcmd                   # determine the pid if necessary
559
560         for _elem in $_keywords; do
561                 if [ "$_elem" != "$rc_arg" ]; then
562                         continue
563                 fi
564
565                                         # if there's a custom ${XXX_cmd},
566                                         # run that instead of the default
567                                         #
568                 eval _cmd=\$${rc_arg}_cmd _precmd=\$${rc_arg}_precmd \
569                     _postcmd=\$${rc_arg}_postcmd
570                 if [ -n "$_cmd" ]; then
571                                         # if the precmd failed and force
572                                         # isn't set, exit
573                                         #
574                         if [ -n "$_precmd" ]; then
575                                 debug "run_rc_command: evaluating ${_precmd}()."
576                                 eval $_precmd $rc_extra_args
577                                 _return=$?
578                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
579                                     return 1
580                         fi
581
582                         if [ -n "$_cmd" ]; then
583                                 debug "run_rc_command: evaluating ${_cmd}()."
584                                 eval $_cmd $rc_extra_args
585                                 _return=$?
586                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
587                                     return 1
588                         fi
589
590                         if [ -n "$_postcmd" ]; then
591                                 debug "run_rc_command: evaluating ${_postcmd}()."
592                                  eval $_postcmd $rc_extra_args
593                                 _return=$?
594                         fi
595                         return $_return
596                 fi
597
598                 case "$rc_arg" in       # default operations...
599
600                 status)
601                         if [ -n "$rc_pid" ]; then
602                                 echo "${name} is running as pid $rc_pid."
603                         else
604                                 echo "${name} is not running."
605                                 return 1
606                         fi
607                         ;;
608
609                 start)
610                         if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
611                                 echo 1>&2 "${name} already running? (pid=$rc_pid)."
612                                 return 1
613                         fi
614
615                         if [ ! -x ${_chroot}${command} ]; then
616                                 info "run_rc_command: cannot run ($command)."
617                                 return 1
618                         fi
619
620                                         # check for required variables,
621                                         # directories, and files
622                                         #
623                         for _f in $required_vars; do
624                                 if ! checkyesno $_f; then
625                                         warn "\$${_f} is not enabled."
626                                         if [ -z "$rc_force" ]; then
627                                                 return 1
628                                         fi
629                                 fi
630                         done
631                         for _f in $required_dirs; do
632                                 if [ ! -d "${_f}/." ]; then
633                                         warn "${_f} is not a directory."
634                                         if [ -z "$rc_force" ]; then
635                                                 return 1
636                                         fi
637                                 fi
638                         done
639                         for _f in $required_files; do
640                                 if [ ! -r "${_f}" ]; then
641                                         warn "${_f} is not readable."
642                                         if [ -z "$rc_force" ]; then
643                                                 return 1
644                                         fi
645                                 fi
646                         done
647
648                                         # if the precmd failed and force
649                                         # isn't set, exit
650                                         #
651                         if [ -n "${_precmd}" ]; then
652                                 debug "run_rc_command: evaluating ${_precmd}()."
653                                 eval $_precmd
654                                 _return=$?
655                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
656                                     return 1
657                         fi
658
659                                         # setup the command to run, and run it
660                                         #
661                         echo "Starting ${name}."
662                         if [ -n "$_chroot" ]; then
663                                 _doit="\
664 ${_nice:+nice -n $_nice }\
665 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
666 $_chroot $command $rc_flags $command_args"
667                         else
668                                 _doit="\
669 ${_chdir:+cd $_chdir; }\
670 ${_nice:+nice -n $_nice }\
671 $command $rc_flags $command_args"
672                                 if [ -n "$_user" ]; then
673                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
674                                 fi
675                         fi
676
677                                         # if the cmd failed and force
678                                         # isn't set, exit
679                                         #
680                         debug "run_rc_command: _doit: $_doit"
681                         eval $_doit
682                         _return=$?
683                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
684
685                                         # finally, run postcmd
686                                         #
687                         if [ -n "${_postcmd}" ]; then
688                                 debug "run_rc_command: evaluating ${_postcmd}()."
689                                 eval $_postcmd
690                         fi
691                         ;;
692
693                 stop)
694                         if [ -z "$rc_pid" ]; then
695                                 [ -n "$rc_fast" ] && return 0
696                                 if [ -n "$pidfile" ]; then
697                                         echo 1>&2 \
698                                     "${name} not running? (check $pidfile)."
699                                 else
700                                         echo 1>&2 "${name} not running?"
701                                 fi
702                                 return 1
703                         fi
704
705                                         # if the precmd failed and force
706                                         # isn't set, exit
707                                         #
708                         if [ -n "$_precmd" ]; then
709                                 eval $_precmd
710                                 _return=$?
711                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
712                                     return 1
713                         fi
714
715                                         # send the signal to stop
716                                         #
717                         echo "Stopping ${name}."
718                         _doit="kill -${sig_stop:-TERM} $rc_pid"
719                         if [ -n "$_user" ]; then
720                                 _doit="su -m $_user -c 'sh -c \"$_doit\"'"
721                         fi
722
723                                         # if the stop cmd failed and force
724                                         # isn't set, exit
725                                         #
726                         eval $_doit
727                         _return=$?
728                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
729
730                                         # wait for the command to exit,
731                                         # and run postcmd.
732                         wait_for_pids $rc_pid
733                         if [ -n "$_postcmd" ]; then
734                                 eval $_postcmd
735                                 _return=$?
736                         fi
737                         ;;
738
739                 reload)
740                         if [ -z "$rc_pid" ]; then
741                                 if [ -n "$pidfile" ]; then
742                                         echo 1>&2 \
743                                     "${name} not running? (check $pidfile)."
744                                 else
745                                         echo 1>&2 "${name} not running?"
746                                 fi
747                                 return 1
748                         fi
749                         echo "Reloading ${name} config files."
750                         if [ -n "$_precmd" ]; then
751                                 eval $_precmd
752                                 _return=$?
753                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
754                                     return 1
755                         fi
756                         _doit="kill -${sig_reload:-HUP} $rc_pid"
757                         if [ -n "$_user" ]; then
758                                 _doit="su -m $_user -c 'sh -c \"$_doit\"'"
759                         fi
760                         eval $_doit
761                         _return=$?
762                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
763                         if [ -n "$_postcmd" ]; then
764                                 eval $_postcmd
765                                 _return=$?
766                         fi
767                         ;;
768
769                 restart)
770                         if [ -n "$_precmd" ]; then
771                                 eval $_precmd $rc_extra_args
772                                 _return=$?
773                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
774                                     return 1
775                         fi
776                                         # prevent restart being called more
777                                         # than once by any given script
778                                         #
779                         if ${_rc_restart_done:-false}; then
780                                 return 0
781                         fi
782                         _rc_restart_done=true
783
784                         # run stop in a subshell to keep variables for start
785                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
786                         run_rc_command ${_rc_prefix}start $rc_extra_args
787
788                         if [ -n "$_postcmd" ]; then
789                                 eval $_postcmd $rc_extra_args
790                                 _return=$?
791                         fi
792                         ;;
793
794                 poll)
795                         if [ -n "$rc_pid" ]; then
796                                 wait_for_pids $rc_pid
797                         fi
798                         ;;
799
800                 rcvar)
801                         echo "# $name"
802                         if [ -n "$rcvar" ]; then
803                                 if checkyesno ${rcvar}; then
804                                         echo "\$${rcvar}=YES"
805                                 else
806                                         echo "\$${rcvar}=NO"
807                                 fi
808                         fi
809                         ;;
810
811                 *)
812                         rc_usage $_keywords
813                         ;;
814
815                 esac
816                 return $_return
817         done
818
819         echo 1>&2 "$0: unknown directive '$rc_arg'."
820         rc_usage $_keywords
821         # not reached
822 }
823
824 #
825 # run_rc_script file arg
826 #       Start the script `file' with `arg', and correctly handle the
827 #       return value from the script.  If `file' ends with `.sh', it's
828 #       sourced into the current environment.  If `file' appears to be
829 #       a backup or scratch file, ignore it.  Otherwise if it's
830 #       executable run as a child process.
831 #
832 run_rc_script()
833 {
834         _file=$1
835         _arg=$2
836         if [ -z "$_file" -o -z "$_arg" ]; then
837                 err 3 'USAGE: run_rc_script file arg'
838         fi
839
840         unset   name command command_args command_interpreter \
841                 extra_commands pidfile procname \
842                 rcvar required_dirs required_files required_vars
843         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
844
845         case "$_file" in
846         /etc/rc.d/*.sh)                 # run in current shell
847                 set $_arg; . $_file
848                 ;;
849         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
850                 warn "Ignoring scratch file $_file"
851                 ;;
852         *)                              # run in subshell
853                 if [ -x $_file ]; then
854                         if [ -n "$rc_fast_and_loose" ]; then
855                                 set $_arg; . $_file
856                         else
857                                 ( trap "echo Script $_file interrupted; kill -QUIT $$" 3
858                                   trap "echo Script $_file interrupted; exit 1" 2
859                                   set $_arg; . $_file )
860                         fi
861                 fi
862                 ;;
863         esac
864 }
865
866 #
867 # load_rc_config name
868 #       Source in the configuration file for a given name.
869 #
870 load_rc_config()
871 {
872         local _tmp
873
874         _name=$1
875         if [ -z "$_name" ]; then
876                 err 3 'USAGE: load_rc_config name'
877         fi
878
879         if ${_rc_conf_loaded:-false}; then
880                 :
881         else
882                 if [ -r /etc/defaults/rc.conf ]; then
883                         debug "Sourcing /etc/defaults/rc.conf"
884                         . /etc/defaults/rc.conf
885                         source_rc_confs
886                 elif [ -r /etc/rc.conf ]; then
887                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
888                         . /etc/rc.conf
889                 fi
890                 _rc_conf_loaded=true
891         fi
892
893         eval _override_command=\$${name}_program
894         command=${command:+${_override_command:-$command}}
895         
896         if [ -z "${command}" ]; then
897                 _tmp=`/bin/realpath $0`
898                 prefix=${_tmp%/etc/rc.d/*}/
899         else
900                 prefix=${command%/*bin/*}/
901         fi
902         if [ "${prefix}" = "/" -o "${prefix}" = "/usr/" ] ; then
903                 etcdir="/etc"
904         else
905                 etcdir="${prefix}etc"
906         fi
907
908         # XXX - Deprecated
909         if [ -f /etc/rc.conf.d/${_name} -a ${etcdir} != "/etc" ]; then
910                 debug "Sourcing /etc/rc.conf.d/${_name}"
911                 warn "Warning: /etc/rc.conf.d/${_name} is deprecated, please use ${etcdir}/rc.conf.d/${_name} instead."
912                 if [ -f ${etcdir}/rc.conf.d/${_name} ]; then
913                         warn "Warning: Both /etc/rc.conf.d/${_name} and ${etcdir}/rc.conf.d/${_name} exist."
914                 fi
915                 . /etc/rc.conf.d/${_name}
916         fi
917
918         if [ -f ${etcdir}/rc.conf.d/${_name} ]; then
919                 debug "Sourcing ${etcdir}/rc.conf.d/${_name}"
920                 . ${etcdir}/rc.conf.d/${_name}
921         fi
922
923         # XXX - Deprecated variable name support
924         #
925         case ${OSTYPE} in
926         FreeBSD)
927                 [ -n "$portmap_enable" ] && rpcbind_enable="$portmap_enable"
928                 [ -n "$portmap_program" ] && rpcbind_program="$portmap_program"
929                 [ -n "$portmap_flags" ] && rpcbind_flags="$portmap_flags"
930                 [ -n "$single_mountd_enable" ] && mountd_enable="$single_mountd_enable"
931                 [ -n "$xntpd_enable" ] && ntpd_enable="$xntpd_enable"
932                 [ -n "$xntpd_program" ] && ntpd_program="$xntpd_program"
933                 [ -n "$xntpd_flags" ] && ntpd_flags="$xntpd_flags"
934                 [ -n "$dhcp_program" ] && dhclient_program="$dhcp_program"
935                 [ -n "$dhcp_flags" ] && dhclient_flags="$dhcp_flags"
936                 ;;
937         esac
938 }
939   
940 #
941 # load_rc_config_var name var
942 #       Read the rc.conf(5) var for name and set in the
943 #       current shell, using load_rc_config in a subshell to prevent
944 #       unwanted side effects from other variable assignments.
945 #
946 load_rc_config_var()
947 {
948         if [ $# -ne 2 ]; then
949                 err 3 'USAGE: load_rc_config_var name var'
950         fi
951         eval $(eval '(
952                 load_rc_config '$1' >/dev/null;
953                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
954                         echo '$2'=\'\''${'$2'}\'\'';
955                 fi
956         )' )
957 }
958
959 #
960 # rc_usage commands
961 #       Print a usage string for $0, with `commands' being a list of
962 #       valid commands.
963 #
964 rc_usage()
965 {
966         echo -n 1>&2 "Usage: $0 [fast|force|one]("
967
968         _sep=
969         for _elem; do
970                 echo -n 1>&2 "$_sep$_elem"
971                 _sep="|"
972         done
973         echo 1>&2 ")"
974         exit 1
975 }
976
977 #
978 # err exitval message
979 #       Display message to stderr and log to the syslog, and exit with exitval.
980 #
981 err()
982 {
983         exitval=$1
984         shift
985
986         if [ -x /usr/bin/logger ]; then
987                 logger "$0: ERROR: $*"
988         fi
989         echo 1>&2 "$0: ERROR: $*"
990         exit $exitval
991 }
992
993 #
994 # warn message
995 #       Display message to stderr and log to the syslog.
996 #
997 warn()
998 {
999         if [ -x /usr/bin/logger ]; then
1000                 logger "$0: WARNING: $*"
1001         fi
1002         echo 1>&2 "$0: WARNING: $*"
1003 }
1004
1005 #
1006 # info message
1007 #       Display informational message to stdout and log to syslog.
1008 #
1009 info()
1010 {
1011         case ${rc_info} in
1012         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1013                 if [ -x /usr/bin/logger ]; then
1014                         logger "$0: INFO: $*"
1015                 fi
1016                 echo "$0: INFO: $*"
1017                 ;;
1018         esac
1019 }
1020
1021 #
1022 # debug message
1023 #       If debugging is enabled in rc.conf output message to stderr.
1024 #       BEWARE that you don't call any subroutine that itself calls this
1025 #       function.
1026 #
1027 debug()
1028 {
1029         case ${rc_debug} in
1030         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1031                 if [ -x /usr/bin/logger ]; then
1032                         logger "$0: INFO: $*"
1033                 fi
1034                 echo 1>&2 "$0: DEBUG: $*"
1035                 ;;
1036         esac
1037 }
1038
1039 #
1040 # backup_file action file cur backup
1041 #       Make a backup copy of `file' into `cur', and save the previous
1042 #       version of `cur' as `backup' or use rcs for archiving.
1043 #
1044 #       This routine checks the value of the backup_uses_rcs variable,
1045 #       which can be either YES or NO.
1046 #
1047 #       The `action' keyword can be one of the following:
1048 #
1049 #       add             `file' is now being backed up (and is possibly
1050 #                       being reentered into the backups system).  `cur'
1051 #                       is created and RCS files, if necessary, are
1052 #                       created as well.
1053 #
1054 #       update          `file' has changed and needs to be backed up.
1055 #                       If `cur' exists, it is copied to to `back' or
1056 #                       checked into RCS (if the repository file is old),
1057 #                       and then `file' is copied to `cur'.  Another RCS
1058 #                       check in done here if RCS is being used.
1059 #
1060 #       remove          `file' is no longer being tracked by the backups
1061 #                       system.  If RCS is not being used, `cur' is moved
1062 #                       to `back', otherwise an empty file is checked in,
1063 #                       and then `cur' is removed.
1064 #
1065 #
1066 backup_file()
1067 {
1068         _action=$1
1069         _file=$2
1070         _cur=$3
1071         _back=$4
1072
1073         if checkyesno backup_uses_rcs; then
1074                 _msg0="backup archive"
1075                 _msg1="update"
1076
1077                 # ensure that history file is not locked
1078                 if [ -f $_cur,v ]; then
1079                         rcs -q -u -U -M $_cur
1080                 fi
1081
1082                 # ensure after switching to rcs that the
1083                 # current backup is not lost
1084                 if [ -f $_cur ]; then
1085                         # no archive, or current newer than archive
1086                         if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1087                                 ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1088                                 rcs -q -kb -U $_cur
1089                                 co -q -f -u $_cur
1090                         fi
1091                 fi
1092
1093                 case $_action in
1094                 add|update)
1095                         cp -p $_file $_cur
1096                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1097                         rcs -q -kb -U $_cur
1098                         co -q -f -u $_cur
1099                         chown root:wheel $_cur $_cur,v
1100                         ;;
1101                 remove)
1102                         cp /dev/null $_cur
1103                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1104                         rcs -q -kb -U $_cur
1105                         chown root:wheel $_cur $_cur,v
1106                         rm $_cur
1107                         ;;
1108                 esac
1109         else
1110                 case $_action in
1111                 add|update)
1112                         if [ -f $_cur ]; then
1113                                 cp -p $_cur $_back
1114                         fi
1115                         cp -p $_file $_cur
1116                         chown root:wheel $_cur
1117                         ;;
1118                 remove)
1119                         mv -f $_cur $_back
1120                         ;;
1121                 esac
1122         fi
1123 }
1124
1125 # make_symlink src link
1126 #       Make a symbolic link 'link' to src from basedir. If the
1127 #       directory in which link is to be created does not exist
1128 #       a warning will be displayed and an error will be returned.
1129 #       Returns 0 on sucess, 1 otherwise.
1130 #
1131 make_symlink()
1132 {
1133         local src link linkdir _me
1134         src="$1"
1135         link="$2"
1136         linkdir="`dirname $link`"
1137         _me="make_symlink()"
1138
1139         if [ -z "$src" -o -z "$link" ]; then
1140                 warn "$_me: requires two arguments."
1141                 return 1
1142         fi
1143         if [ ! -d "$linkdir" ]; then
1144                 warn "$_me: the directory $linkdir does not exist"
1145                 return 1
1146         fi
1147         if ! ln -sf $src $link; then
1148                 warn "$_me: unable to make a symbolic link from $link to $src"
1149                 return 1
1150         fi
1151         return 0
1152 }
1153
1154 # devfs_rulesets_from_file file
1155 #       Reads a set of devfs commands from file, and creates
1156 #       the specified rulesets with their rules. Returns non-zero
1157 #       if there was an error.
1158 #
1159 devfs_rulesets_from_file()
1160 {
1161         local file _err _me
1162         file="$1"
1163         _me="devfs_rulesets_from_file"
1164         _err=0
1165
1166         if [ -z "$file" ]; then
1167                 warn "$_me: you must specify a file"
1168                 return 1
1169         fi
1170         if [ ! -e "$file" ]; then
1171                 debug "$_me: no such file ($file)"
1172                 return 0
1173         fi
1174         debug "reading rulesets from file ($file)"
1175         { while read line
1176         do
1177                 case $line in
1178                 \#*)
1179                         continue
1180                         ;;
1181                 \[*\]*)
1182                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1183                         if [ -z "$rulenum" ]; then
1184                                 warn "$_me: cannot extract rule number ($line)"
1185                                 _err=1
1186                                 break
1187                         fi
1188                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1189                         if [ -z "$rulename" ]; then
1190                                 warn "$_me: cannot extract rule name ($line)"
1191                                 _err=1
1192                                 break;
1193                         fi
1194                         eval $rulename=\$rulenum
1195                         debug "found ruleset: $rulename=$rulenum"
1196                         if ! /sbin/devfs rule -s $rulenum delset; then
1197                                 _err=1
1198                                 break
1199                         fi
1200                         ;;
1201                 *)
1202                         rulecmd="${line%%"\#*"}"
1203                         # evaluate the command incase it includes
1204                         # other rules
1205                         if [ -n "$rulecmd" ]; then
1206                                 debug "adding rule ($rulecmd)"
1207                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1208                                 then
1209                                         _err=1
1210                                         break
1211                                 fi
1212                         fi
1213                         ;;
1214                 esac
1215                 if [ $_err -ne 0 ]; then
1216                         debug "error in $_me"
1217                         break
1218                 fi
1219         done } < $file
1220         return $_err
1221 }
1222
1223 # devfs_init_rulesets
1224 #       Initializes rulesets from configuration files. Returns
1225 #       non-zero if there was an error.
1226 #
1227 devfs_init_rulesets()
1228 {
1229         local file _me
1230         _me="devfs_init_rulesets"
1231
1232         # Go through this only once
1233         if [ -n "$devfs_rulesets_init" ]; then
1234                 debug "$_me: devfs rulesets already initialized"
1235                 return
1236         fi
1237         for file in $devfs_rulesets; do
1238                 devfs_rulesets_from_file $file || return 1
1239         done
1240         devfs_rulesets_init=1
1241         debug "$_me: devfs rulesets initialized"
1242         return 0
1243 }
1244
1245 # devfs_set_ruleset ruleset [dir]
1246 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1247 #       must be a ruleset name as specified in devfs.rules(5) file.
1248 #       Returns non-zero if it could not set it successfully.
1249 #
1250 devfs_set_ruleset()
1251 {
1252         local devdir rs _me
1253         [ -n "$1" ] && eval rs=\$$1 || rs=
1254         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1255         _me="devfs_set_ruleset"
1256
1257         if [ -z "$rs" ]; then
1258                 warn "$_me: you must specify a ruleset number"
1259                 return 1
1260         fi
1261         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1262         if ! /sbin/devfs $devdir ruleset $rs; then
1263                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1264                 return 1
1265         fi
1266         return 0
1267 }
1268
1269 # devfs_apply_ruleset ruleset [dir]
1270 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1271 #       The ruleset argument must be a ruleset name as specified
1272 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1273 #       if it could not apply the ruleset.
1274 #
1275 devfs_apply_ruleset()
1276 {
1277         local devdir rs _me
1278         [ -n "$1" ] && eval rs=\$$1 || rs=
1279         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1280         _me="devfs_apply_ruleset"
1281
1282         if [ -z "$rs" ]; then
1283                 warn "$_me: you must specify a ruleset"
1284                 return 1
1285         fi
1286         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1287         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1288                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1289                 return 1
1290         fi
1291         return 0
1292 }
1293
1294 # devfs_domount dir [ruleset]
1295 #       Mount devfs on dir. If ruleset is specified it is set
1296 #       on the mount-point. It must also be a ruleset name as specified
1297 #       in a devfs.rules(5) file. Returns 0 on success.
1298 #
1299 devfs_domount()
1300 {
1301         local devdir rs _me
1302         devdir="$1"
1303         [ -n "$2" ] && rs=$2 || rs=
1304         _me="devfs_domount()"
1305
1306         if [ -z "$devdir" ]; then
1307                 warn "$_me: you must specify a mount-point"
1308                 return 1
1309         fi
1310         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1311         if ! mount -t devfs dev "$devdir"; then
1312                 warn "$_me: Unable to mount devfs on $devdir"
1313                 return 1
1314         fi
1315         if [ -n "$rs" ]; then
1316                 devfs_init_rulesets
1317                 devfs_set_ruleset $rs $devdir
1318                 devfs -m $devdir rule applyset
1319         fi
1320         return 0
1321 }
1322
1323 # devfs_mount_jail dir [ruleset]
1324 #       Mounts a devfs file system appropriate for jails
1325 #       on the directory dir. If ruleset is specified, the ruleset
1326 #       it names will be used instead.  If present, ruleset must
1327 #       be the name of a ruleset as defined in a devfs.rules(5) file.
1328 #       This function returns non-zero if an error occurs.
1329 #
1330 devfs_mount_jail()
1331 {
1332         local jdev rs _me
1333         jdev="$1"
1334         [ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1335         _me="devfs_mount_jail"
1336
1337         devfs_init_rulesets
1338         if ! devfs_domount "$jdev" $rs; then
1339                 warn "$_me: devfs was not mounted on $jdev"
1340                 return 1
1341         fi
1342         return 0
1343 }
1344
1345 # Provide a function for normalizing the mounting of memory
1346 # filesystems.  This should allow the rest of the code here to remain
1347 # as close as possible between 5-current and 4-stable.
1348 #   $1 = size
1349 #   $2 = mount point
1350 #   $3 = (optional) extra mdmfs flags
1351 mount_md()
1352 {
1353         if [ -n "$3" ]; then
1354                 flags="$3"
1355         fi
1356         /sbin/mdmfs $flags -s $1 md $2
1357 }
1358
1359 # ltr str src dst
1360 #       Change every $src in $str to $dst.
1361 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1362 #       awk(1).
1363 ltr()
1364 {
1365         local _str _src _dst _out _com
1366         _str=$1
1367         _src=$2
1368         _dst=$3
1369         _out=""
1370
1371         IFS=${_src}
1372         for _com in ${_str}; do
1373                 if [ -z "${_out}" ]; then
1374                         _out="${_com}"
1375                 else
1376                         _out="${_out}${_dst}${_com}"
1377                 fi
1378         done
1379         echo "${_out}"
1380 }
1381
1382 # Creates a list of providers for GELI encryption.
1383 geli_make_list()
1384 {
1385         local devices devices2
1386         local provider mountpoint type options rest
1387
1388         # Create list of GELI providers from fstab.
1389         while read provider mountpoint type options rest ; do
1390                 case ":${options}" in
1391                 :*noauto*)
1392                         noauto=yes
1393                         ;;
1394                 *)
1395                         noauto=no
1396                         ;;
1397                 esac
1398
1399                 case ":${provider}" in
1400                 :#*)
1401                         continue
1402                         ;;
1403                 *.eli)
1404                         # Skip swap devices.
1405                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1406                                 continue
1407                         fi
1408                         devices="${devices} ${provider}"
1409                         ;;
1410                 esac
1411         done < /etc/fstab
1412
1413         # Append providers from geli_devices.
1414         devices="${devices} ${geli_devices}"
1415
1416         for provider in ${devices}; do
1417                 provider=${provider%.eli}
1418                 provider=${provider#/dev/}
1419                 devices2="${devices2} ${provider}"
1420         done
1421
1422         echo ${devices2}
1423 }
1424
1425 # Find scripts in local_startup directories that use the old syntax
1426 #
1427 find_local_scripts_old () {
1428         zlist=''
1429         slist=''
1430         for dir in ${local_startup}; do
1431                 if [ -d "${dir}" ]; then
1432                         for file in ${dir}/[0-9]*.sh; do
1433                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1434                                     continue
1435                                 zlist="$zlist $file"
1436                         done
1437                         for file in ${dir}/[^0-9]*.sh; do
1438                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1439                                     continue
1440                                 slist="$slist $file"
1441                         done
1442                 fi
1443         done
1444 }
1445
1446 find_local_scripts_new () {
1447         local_rc=''
1448         for dir in ${local_startup}; do
1449                 if [ -d "${dir}" ]; then
1450                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1451                                 case "$file" in
1452                                 *.sample) ;;
1453                                 *)      if [ -x "$file" ]; then
1454                                                 local_rc="${local_rc} ${file}"
1455                                         fi
1456                                         ;;
1457                                 esac
1458                         done
1459                 fi
1460         done
1461 }
1462
1463 fi
1464
1465 _rc_subr_loaded=: